package org.implab.gradle.mercurial;

import java.util.Objects;

public class WorkspaceInfo {
    private final String versionTag;

    private final int versionDistance;

    private final String branch;

    private final String changeset;

    private final boolean isDirty;

    public WorkspaceInfo(String versionTag, int versionDistance, String branch, String changeset, boolean isDirty) {
        this.versionTag = versionTag;
        this.versionDistance = versionDistance;
        this.branch = Objects.requireNonNull(branch);
        this.changeset = Objects.requireNonNull(changeset);
        this.isDirty = isDirty;
    }

    public String getChangeset() {
        return changeset;
    }

    public String getVersionTag() {
        return versionTag;
    }

    public int getVersionDistance() {
        return versionDistance;
    }

    public String getBranch() {
        return branch;
    }

    public boolean getIsDirty() {
        return isDirty;
    }


    @Override
    public String toString() {
        return String.format("{ changeset=%s, branch=%s, versionTag=%s, distance=%s, isDirty=%s}", changeset, branch,
                versionTag, versionDistance, isDirty);
    }

}
